<?php
# wp-pda Plugin
# Version - 1.0
# For Wordpress 2.0.X and above
# <http://imthi.com/wp-pda/>
#
# $Id: pda.php 10 2007-03-05 05:12:17Z imthiaz $
#
# This plugin is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This plugin is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this plugin; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# For questions, help, comments, discussion, etc., 
# please maill to hmimthiaz for the domain imthi dot com 
# or visit http://imthi.com/wp-pda/

/*
Plugin Name: Wordpress PDA
Plugin URI: http://imthi.com/wp-pda/
Description: This plugin helps the users to view your blog in a pda browser.
Author: Imthiaz Rafiq
Version: 1.0
Author URI: http://imthi.com/
*/ 

class PDAPlugin{
	var $pda;
	
	function PDAPlugin(){
		$this->pda = false;
		
		add_action('plugins_loaded',array(&$this,'detectPDA'));
		
		add_filter('theme_root',array(&$this,'theme_root'));
		add_filter('theme_root_uri',array(&$this,'get_theme_root_uri'));
		add_filter('stylesheet',array(&$this,'get_stylesheet'));
		add_filter('template',array(&$this,'get_template'));
		add_filter('option_template',array(&$this,'get_template_directory'));
		add_filter('option_stylesheet',array(&$this,'get_template_directory'));
	}

	function detectPDA($query){
		$container = $_SERVER['HTTP_USER_AGENT'];
		$useragents = array (
			"Elaine/3.0","Palm","EudoraWeb","Blazer","AvantGo","Windows CE","Cellphone","Small","MMEF20","Danger","hiptop"
			,"Proxinet","ProxiNet","Newt","PalmOS","NetFront","SHARP-TQ-GX10","SonyEricsson","SymbianOS","UP.Browser"
			,"UP.Link","TS21i-10","BlackBerry","MOT-V",'portalmmm','Nokia','DoCoMo','Opera Mini'
			,"Palm" ,"Handspring","Nokia","Kyocera","Samsung","Motorola","Mot" ,"Smartphone","Blackberry"
			,"WAP","PlayStation Portable","LG","MMP","OPWV","Symbian","EPOC");
		$this->pda = false;
		foreach ( $useragents as $useragent ) {
			if (eregi($useragent,$container)){
				$this->pda = true;
			}
		}
	}
	
	function get_template_directory($value){
		if($this->pda){
			return 'pda-theme';
		}else{
			return $value;
		}
	}
	
	function theme_root($path){
		$theme_root = dirname(__FILE__);
		if($this->pda){
			return $theme_root;
		}else{
			return $path;
		}
	}
	
	function get_theme_root_uri($url){
		if($this->pda){
			return get_settings('siteurl') . "/wp-content/plugins/wp-pda";
		}else{
			return $url;
		}
	}
	
	function get_stylesheet($stylesheet) {
		if($this->pda){
			return 'pda-theme';
		}else{
			return $stylesheet;
		}
	}
	
	function get_template($template) {
		if($this->pda){
			return 'pda-theme';
		}else{
			return $template;
		}
	}
}
$wp_pda = new PDAPlugin();
?>